# import packages
import pandas as pd
# import numpy as np
import os
from scipy.signal import butter, filtfilt
import cv2
# import matplotlib
# # matplotlib.use('TkAgg')
# import matplotlib.pyplot as plt

# uncomment for interactive figure
from pylab import *
matplotlib.use("TkAgg")
import matplotlib.animation as animation

#################################################
def Butterworth_filter(keypoints, frq=25):
    keypoints_filt = pd.DataFrame()
    # filter data
    b, a = butter(4, 10 / frq, 'low', analog=False)
    for col in keypoints:
        keypoints_filt[col] = filtfilt(b, a, keypoints[col], padlen=5)
    return keypoints_filt

def conditional_filter(keypoints):
    # find and correct keypoints flipping left and right
    # find flip in keypoints
    keypoints1 = keypoints.copy()
    left = keypoints['LAnkle_y'].copy()
    right = keypoints['RAnkle_y'].copy()
    diff_left = left.diff()
    diff_left[abs(diff_left) < 70] = np.nan  # threshold of 70 is chosen based on the data
    diff_right = right.diff()
    diff_right[abs(diff_right) < 70] = np.nan  # threshold of 70 is chosen based on the data
    res = diff_left.notnull() & diff_right.notnull()
    idx = res[res].index

    if len(idx) == 2:
        keypoints1['LSmallToe_y'].iloc[idx[0]:idx[1]] = keypoints['RSmallToe_y'].iloc[idx[0]:idx[1]]
        keypoints1['RSmallToe_y'].iloc[idx[0]:idx[1]] = keypoints['LSmallToe_y'].iloc[idx[0]:idx[1]]
        keypoints1['LSmallToe_x'].iloc[idx[0]:idx[1]] = keypoints['RSmallToe_x'].iloc[idx[0]:idx[1]]
        keypoints1['RSmallToe_x'].iloc[idx[0]:idx[1]] = keypoints['LSmallToe_x'].iloc[idx[0]:idx[1]]

        keypoints1['LBigToe_y'].iloc[idx[0]:idx[1]] = keypoints['RBigToe_y'].iloc[idx[0]:idx[1]]
        keypoints1['RBigToe_y'].iloc[idx[0]:idx[1]] = keypoints['LBigToe_y'].iloc[idx[0]:idx[1]]
        keypoints1['LBigToe_x'].iloc[idx[0]:idx[1]] = keypoints['RBigToe_x'].iloc[idx[0]:idx[1]]
        keypoints1['RBigToe_x'].iloc[idx[0]:idx[1]] = keypoints['LBigToe_x'].iloc[idx[0]:idx[1]]

        keypoints1['LHeel_y'].iloc[idx[0]:idx[1]] = keypoints['RHeel_y'].iloc[idx[0]:idx[1]]
        keypoints1['RHeel_y'].iloc[idx[0]:idx[1]] = keypoints['LHeel_y'].iloc[idx[0]:idx[1]]
        keypoints1['LHeel_x'].iloc[idx[0]:idx[1]] = keypoints['RHeel_x'].iloc[idx[0]:idx[1]]
        keypoints1['RHeel_x'].iloc[idx[0]:idx[1]] = keypoints['LHeel_x'].iloc[idx[0]:idx[1]]

        keypoints1['LAnkle_y'].iloc[idx[0]:idx[1]] = keypoints['RAnkle_y'].iloc[idx[0]:idx[1]]
        keypoints1['RAnkle_y'].iloc[idx[0]:idx[1]] = keypoints['LAnkle_y'].iloc[idx[0]:idx[1]]
        keypoints1['LAnkle_x'].iloc[idx[0]:idx[1]] = keypoints['RAnkle_x'].iloc[idx[0]:idx[1]]
        keypoints1['RAnkle_x'].iloc[idx[0]:idx[1]] = keypoints['LAnkle_x'].iloc[idx[0]:idx[1]]

        keypoints1['LKnee_y'].iloc[idx[0]:idx[1]] = keypoints['RKnee_y'].iloc[idx[0]:idx[1]]
        keypoints1['RKnee_y'].iloc[idx[0]:idx[1]] = keypoints['LKnee_y'].iloc[idx[0]:idx[1]]
        keypoints1['LKnee_x'].iloc[idx[0]:idx[1]] = keypoints['RKnee_x'].iloc[idx[0]:idx[1]]
        keypoints1['RKnee_x'].iloc[idx[0]:idx[1]] = keypoints['LKnee_x'].iloc[idx[0]:idx[1]]

        keypoints1['LHip_y'].iloc[idx[0]:idx[1]] = keypoints['RHip_y'].iloc[idx[0]:idx[1]]
        keypoints1['RHip_y'].iloc[idx[0]:idx[1]] = keypoints['LHip_y'].iloc[idx[0]:idx[1]]
        keypoints1['LHip_x'].iloc[idx[0]:idx[1]] = keypoints['RHip_x'].iloc[idx[0]:idx[1]]
        keypoints1['RHip_x'].iloc[idx[0]:idx[1]] = keypoints['LHip_x'].iloc[idx[0]:idx[1]]

    # find if left and right have been swapped
    keypoints2 = keypoints1.copy()
    left = keypoints1['LAnkle_x'].copy()
    right = keypoints1['RAnkle_x'].copy()
    diff_left = left.diff()
    diff_left[abs(diff_left) < 150] = np.nan # threshold of 150 is chosen based on the data
    diff_right = right.diff()
    diff_right[abs(diff_right) < 150] = np.nan # threshold of 150 is chosen based on the data
    res = diff_left.notnull() & diff_right.notnull()
    idx = res[res].index

    if len(idx) == 1:
        keypoints2['LSmallToe_y'].iloc[idx[0]:] = keypoints1['RSmallToe_y'].iloc[idx[0]:]
        keypoints2['RSmallToe_y'].iloc[idx[0]:] = keypoints1['LSmallToe_y'].iloc[idx[0]:]
        keypoints2['LSmallToe_x'].iloc[idx[0]:] = keypoints1['RSmallToe_x'].iloc[idx[0]:]
        keypoints2['RSmallToe_x'].iloc[idx[0]:] = keypoints1['LSmallToe_x'].iloc[idx[0]:]

        keypoints2['LBigToe_y'].iloc[idx[0]:] = keypoints1['RBigToe_y'].iloc[idx[0]:]
        keypoints2['RBigToe_y'].iloc[idx[0]:] = keypoints1['LBigToe_y'].iloc[idx[0]:]
        keypoints2['LBigToe_x'].iloc[idx[0]:] = keypoints1['RBigToe_x'].iloc[idx[0]:]
        keypoints2['RBigToe_x'].iloc[idx[0]:] = keypoints1['LBigToe_x'].iloc[idx[0]:]

        keypoints2['LHeel_y'].iloc[idx[0]:] = keypoints1['RHeel_y'].iloc[idx[0]:]
        keypoints2['RHeel_y'].iloc[idx[0]:] = keypoints1['LHeel_y'].iloc[idx[0]:]
        keypoints2['LHeel_x'].iloc[idx[0]:] = keypoints1['RHeel_x'].iloc[idx[0]:]
        keypoints2['RHeel_x'].iloc[idx[0]:] = keypoints1['LHeel_x'].iloc[idx[0]:]

        keypoints2['LAnkle_y'].iloc[idx[0]:] = keypoints1['RAnkle_y'].iloc[idx[0]:]
        keypoints2['RAnkle_y'].iloc[idx[0]:] = keypoints1['LAnkle_y'].iloc[idx[0]:]
        keypoints2['LAnkle_x'].iloc[idx[0]:] = keypoints1['RAnkle_x'].iloc[idx[0]:]
        keypoints2['RAnkle_x'].iloc[idx[0]:] = keypoints1['LAnkle_x'].iloc[idx[0]:]

        keypoints2['LKnee_y'].iloc[idx[0]:] = keypoints1['RKnee_y'].iloc[idx[0]:]
        keypoints2['RKnee_y'].iloc[idx[0]:] = keypoints1['LKnee_y'].iloc[idx[0]:]
        keypoints2['LKnee_x'].iloc[idx[0]:] = keypoints1['RKnee_x'].iloc[idx[0]:]
        keypoints2['RKnee_x'].iloc[idx[0]:] = keypoints1['LKnee_x'].iloc[idx[0]:]

        keypoints2['LHip_y'].iloc[idx[0]:] = keypoints1['RHip_y'].iloc[idx[0]:]
        keypoints2['RHip_y'].iloc[idx[0]:] = keypoints1['LHip_y'].iloc[idx[0]:]
        keypoints2['LHip_x'].iloc[idx[0]:] = keypoints1['RHip_x'].iloc[idx[0]:]
        keypoints2['RHip_x'].iloc[idx[0]:] = keypoints1['LHip_x'].iloc[idx[0]:]

    # check for keypoints that drop out
    keypoints3 = keypoints2.copy()
    keypoints3 = keypoints3.replace(0, np.nan)

    # drop columns that are missing more than 10 values
    to_drop = np.where(keypoints3.isnull().values.sum(axis=0) > 10)
    keypoints3 = keypoints3.drop(keypoints3.columns[to_drop], axis=1)

    # fill single dropouts
    single_gaps = keypoints3.columns[np.where(keypoints3.isnull().values.sum(axis=0) == 1)]
    for i in range(len(single_gaps)):
        keypoints3[single_gaps[i]] = keypoints3[single_gaps[i]].interpolate()

    return keypoints1, keypoints2, keypoints3

def plot_original_keypoints(keypoints_orig):
    keypoints_x = keypoints_orig.filter(like='_x')
    keypoints_y = keypoints_orig.filter(like='_y')

    x = np.linspace(0, (len(keypoints_orig) - 1) * 40, num=len(keypoints_orig))
    subplots_x = 5
    subplots_y = 5

    plt.figure(num='trajectory')
    for k in range(keypoints_x.shape[1]):
        data = keypoints_x.columns[k]
        k = k + 1
        plt.subplot(subplots_x, subplots_y, k)
        plt.title(data)
        plt.plot(x, keypoints_x[data], '*-r')
        plt.xticks([])
        plt.yticks([])
    plt.show()

    plt.figure(num='trajectory')
    for k in range(keypoints_y.shape[1]):
        data = keypoints_y.columns[k]
        k = k + 1
        plt.subplot(subplots_x, subplots_y, k)
        plt.title(data)
        plt.plot(x, keypoints_y[data], '*-r')
        plt.xticks([])
        plt.yticks([])
    plt.show()

def plot_flip_keypoints(keypoints_orig, keypoints_flip):
    keypoints_x = keypoints_orig.filter(like='_x')
    keypoints_y = keypoints_orig.filter(like='_y')
    keypoints_flip_x = keypoints_flip.filter(like='_x')
    keypoints_flip_y = keypoints_flip.filter(like='_y')

    x = np.linspace(0, (len(keypoints_orig) - 1) * 40, num=len(keypoints_orig))
    subplots_x = 5
    subplots_y = 5

    plt.figure(num='trajectory')
    for k in range(keypoints_x.shape[1]):
        data = keypoints_x.columns[k]
        k = k + 1
        plt.subplot(subplots_x, subplots_y, k)
        plt.title(data)
        plt.plot(x, keypoints_x[data], '*r')
        plt.plot(x, keypoints_flip_x[data], '*g')
        plt.xticks([])
        plt.yticks([])
    plt.show()

    plt.figure(num='trajectory')
    for k in range(keypoints_y.shape[1]):
        data = keypoints_y.columns[k]
        k = k + 1
        plt.subplot(subplots_x, subplots_y, k)
        plt.title(data)
        plt.plot(x, keypoints_y[data], '*-r')
        plt.plot(x, keypoints_flip_y[data], '*g')
        plt.xticks([])
        plt.yticks([])
    plt.show()

def plot_swap_keypoints(keypoints_orig, keypoints_flip, keypoints_swap):
    keypoints_x = keypoints_orig.filter(like='_x')
    keypoints_y = keypoints_orig.filter(like='_y')
    keypoints_flip_x = keypoints_flip.filter(like='_x')
    keypoints_flip_y = keypoints_flip.filter(like='_y')
    keypoints_swap_x = keypoints_swap.filter(like='_x')
    keypoints_swap_y = keypoints_swap.filter(like='_y')

    x = np.linspace(0, (len(keypoints_orig) - 1) * 40, num=len(keypoints_orig))
    subplots_x = 5
    subplots_y = 5

    plt.figure(num='trajectory')
    for k in range(keypoints_x.shape[1]):
            data = keypoints_x.columns[k]
            k = k + 1
            plt.subplot(subplots_x, subplots_y, k)
            plt.title(data)
            plt.plot(x, keypoints_x[data], '*r')
            plt.plot(x, keypoints_flip_x[data], '*g')
            plt.plot(x, keypoints_swap_x[data], '-b')
            plt.xticks([])
            plt.yticks([])
    plt.show()

    plt.figure(num='trajectory')
    for k in range(keypoints_y.shape[1]):
        data = keypoints_y.columns[k]
        k = k + 1
        plt.subplot(subplots_x, subplots_y, k)
        plt.title(data)
        plt.plot(x, keypoints_y[data], '*-r')
        plt.plot(x, keypoints_flip_y[data], '*g')
        plt.plot(x, keypoints_swap_y[data], '-b')
        plt.xticks([])
        plt.yticks([])
    plt.show()

def plot_drop_keypoints(keypoints_orig, keypoints_drop):
    keypoints_x = keypoints_orig.filter(like='_x')
    keypoints_y = keypoints_orig.filter(like='_y')
    keypoints_drop_x = keypoints_drop.filter(like='_x')
    keypoints_drop_y = keypoints_drop.filter(like='_y')

    x = np.linspace(0, (len(keypoints_orig) - 1) * 40, num=len(keypoints_orig))
    subplots_x = 5
    subplots_y = 5

    plt.figure(num='trajectory')
    for k in range(keypoints_drop_x.shape[1]):
        data = keypoints_drop_x.columns[k]
        k = k + 1
        plt.subplot(subplots_x, subplots_y, k)
        plt.title(data)
        plt.plot(x, keypoints_x[data], '*r')
        plt.plot(x, keypoints_drop_x[data], 'g')
        plt.xticks([])
        plt.yticks([])
    plt.show()

    plt.figure(num='trajectory')
    for k in range(keypoints_drop_y.shape[1]):
        data = keypoints_drop_y.columns[k]
        k = k + 1
        plt.subplot(subplots_x, subplots_y, k)
        plt.title(data)
        plt.plot(x, keypoints_y[data], '*r')
        plt.plot(x, keypoints_drop_y[data], 'g')
        plt.xticks([])
        plt.yticks([])
    plt.show()

def plot_butter_keypoints(keypoints_orig, keypoints_drop, keypoints_butter):
    keypoints_x = keypoints_orig.filter(like='_x')
    keypoints_y = keypoints_orig.filter(like='_y')
    keypoints_drop_x = keypoints_drop.filter(like='_x')
    keypoints_drop_y = keypoints_drop.filter(like='_y')
    keypoints_butter_x = keypoints_butter.filter(like='_x')
    keypoints_butter_y = keypoints_butter.filter(like='_y')

    x = np.linspace(0, (len(keypoints_orig) - 1) * 40, num=len(keypoints_orig))
    subplots_x = 5
    subplots_y = 5

    plt.figure(num='trajectory')
    for k in range(keypoints_butter_x.shape[1]):
            data = keypoints_butter_x.columns[k]
            k = k + 1
            plt.subplot(subplots_x, subplots_y, k)
            plt.title(data)
            plt.plot(x, keypoints_x[data], '*r')
            plt.plot(x, keypoints_drop_x[data], '*g')
            plt.plot(x, keypoints_butter_x[data], '-b')
            plt.xticks([])
            plt.yticks([])
    plt.show()

    plt.figure(num='trajectory')
    for k in range(keypoints_butter_y.shape[1]):
        data = keypoints_butter_y.columns[k]
        k = k + 1
        plt.subplot(subplots_x, subplots_y, k)
        plt.title(data)
        plt.plot(x, keypoints_y[data], '*-r')
        plt.plot(x, keypoints_drop_y[data], '*g')
        plt.plot(x, keypoints_butter_y[data], '-b')
        plt.xticks([])
        plt.yticks([])
    plt.show()

def animate_func(i):
    fig.clear()
    flag, frame = cap.read()
    plt.imshow(frame)

    # OpenPose
    # uface = OpenPose[['REar X', 'REye X', 'Nose X', 'LEye X', 'LEar X']].iloc[i]
    # vface = OpenPose[['REar Y', 'REye Y', 'Nose Y', 'LEye Y', 'LEar Y']].iloc[i]
    # ax.scatter(uface, vface, color='g', size=0)
    # ax.plot(uface, vface, color='g')

    urightarm = keypoints_openpose[['RShoulder_x', 'RElbow_x', 'RWrist_x']].iloc[i]
    vrightarm = keypoints_openpose[['RShoulder_y', 'RElbow_y', 'RWrist_y']].iloc[i]
    plt.scatter(urightarm, vrightarm, color='r', s=0)
    plt.plot(urightarm, vrightarm, color='r')

    uleftarm = keypoints_openpose[['LShoulder_x', 'LElbow_x', 'LWrist_x']].iloc[i]
    vleftarm = keypoints_openpose[['LShoulder_y', 'LElbow_y', 'LWrist_y']].iloc[i]
    plt.scatter(uleftarm, vleftarm, color='g', s=0)
    plt.plot(uleftarm, vleftarm, color='g')

    ubody = keypoints_openpose[['Neck_x', 'MidHip_x']].iloc[i]
    vbody = keypoints_openpose[['Neck_y', 'MidHip_y']].iloc[i]
    plt.scatter(ubody, vbody, color='b', s=0)
    plt.plot(ubody, vbody, color='b')

    uleftleg = keypoints_openpose[['LHeel_x', 'LAnkle_x', 'LKnee_x', 'LHip_x']].iloc[i]
    vleftleg = keypoints_openpose[['LHeel_y', 'LAnkle_y', 'LKnee_y', 'LHip_y']].iloc[i]
    plt.scatter(uleftleg, vleftleg, color='g', s=0)
    plt.plot(uleftleg, vleftleg, color='g')

    urightleg = keypoints_openpose[['RHeel_x', 'RAnkle_x', 'RKnee_x', 'RHip_x']].iloc[i]
    vrightleg = keypoints_openpose[['RHeel_y', 'RAnkle_y', 'RKnee_y', 'RHip_y']].iloc[i]
    plt.scatter(urightleg, vrightleg, color='r', s=0)
    plt.plot(urightleg, vrightleg, color='r')

    uleftfoot = keypoints_openpose[['LAnkle_x', 'LBigToe_x', 'LSmallToe_x']].iloc[i]
    vleftfoot = keypoints_openpose[['LAnkle_y', 'LBigToe_y', 'LSmallToe_y']].iloc[i]
    plt.scatter(uleftfoot, vleftfoot, color='g', s=0)
    plt.plot(uleftfoot, vleftfoot, color='g')

    urightfoot = keypoints_openpose[['RAnkle_x', 'RBigToe_x', 'RSmallToe_x']].iloc[i]
    vrightfoot = keypoints_openpose[['RAnkle_y', 'RBigToe_y', 'RSmallToe_y']].iloc[i]
    plt.scatter(urightfoot, vrightfoot, color='r', s=0)
    plt.plot(urightfoot, vrightfoot, color='r')

#################################################
# Load data
path = os.path.dirname(__file__)
keypoints_orig = pd.read_csv(os.path.join(path, 'DATA\\poseestimation\\P01_L_RUNNING_14_TS.csv'))
keypoints_orig = keypoints_orig.replace(np.nan, 0) # replace nan by 0

# cut to relevant frames (6 frames before foot strike and 6 frames after toe off)
# fs and fo have been detected manually
fs = 15
fo = 21
keypoints_orig = keypoints_orig[fs - 6:fo + 6].reset_index(drop=True)

# create copy of original keypoints to avoid overwriting
keypoints = keypoints_orig.copy()

# conditional filter
keypoints_flip, keypoints_swap, keypoints_drop = conditional_filter(keypoints)

# Butterworth filter
keypoints_butter = Butterworth_filter(keypoints_drop)

# plot keypoints
# plot_original_keypoints(keypoints_orig)
# plot_flip_keypoints(keypoints_orig, keypoints_flip)
# plot_swap_keypoints(keypoints_orig, keypoints_flip, keypoints_swap)
# plot_drop_keypoints(keypoints_orig, keypoints_drop)
# plot_drop_keypoints(keypoints_drop, keypoints_butter)
# plot_butter_keypoints(keypoints_orig, keypoints_drop, keypoints_butter)

# overlay video
video = os.path.join(path, 'DATA\\poseestimation\\P01_L_RUNNING_14_TS.mp4')
# video = os.path.join(path, 'DATA\\poseestimation\\P01_L_RUNNING_14_TS_pose.mp4')

cap = cv2.VideoCapture(video)
cap.set(cv2.CAP_PROP_POS_FRAMES, fs-7) # set correct video frames
keypoints_openpose = keypoints_butter.copy()

fig = plt.figure()
anim = animation.FuncAnimation(fig, animate_func, frames=range(0, len(keypoints_openpose)))
anim.save(path + '\\DATA\\poseestimation\\P01_L_RUNNING_14_TS_overlay.mp4',
          writer=animation.FFMpegWriter(fps=1))

#############
x = np.linspace(0, (len(keypoints_orig) - 1) * 40, num=len(keypoints_orig))
plt.figure(num='trajectory')
plt.subplot(2, 1, 1)
plt.title('Ankle x')
# plt.plot(x, keypoints_orig['LAnkle_x'], '*g')
# plt.plot(x, keypoints_orig['RAnkle_x'], '*r')
# plt.plot(x, keypoints_flip['LAnkle_x'], '-g')
# plt.plot(x, keypoints_flip['RAnkle_x'], '-r')
# plt.plot(x, keypoints_swap['LAnkle_x'], '-b')
# plt.plot(x, keypoints_swap['RAnkle_x'], '-b')
plt.plot(x, keypoints_drop['LAnkle_x'], '-k')
plt.plot(x, keypoints_drop['RAnkle_x'], '-k')
plt.plot(x, keypoints_butter['LAnkle_x'], '-c')
plt.plot(x, keypoints_butter['RAnkle_x'], '-c')
plt.xticks([])
plt.subplot(2, 1, 2)
plt.title('Ankle y')
# plt.plot(x, keypoints_orig['LAnkle_y'], '*g')
# plt.plot(x, keypoints_orig['RAnkle_y'], '*r')
# plt.plot(x, keypoints_flip['LAnkle_y'], '-g')
# plt.plot(x, keypoints_flip['RAnkle_y'], '-r')
# plt.plot(x, keypoints_swap['LAnkle_y'], '-b')
# plt.plot(x, keypoints_swap['RAnkle_y'], '-b')
plt.plot(x, keypoints_drop['LAnkle_y'], '-k')
plt.plot(x, keypoints_drop['RAnkle_y'], '-k')
plt.plot(x, keypoints_butter['LAnkle_y'], '-c')
plt.plot(x, keypoints_butter['RAnkle_y'], '-c')
# plt.xticks([])
# plt.yticks([])
plt.show()